var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable } from '@angular/core';
import { Platform } from 'ionic-angular';
import { Device as IonicDevice } from '@ionic-native/device';
import { BatteryStatus } from '@ionic-native/battery-status';
import { AppVersion } from '@ionic-native/app-version';
import 'rxjs/add/operator/map';
import { Utils } from '../utils';
var DeviceMock = (function (_super) {
    __extends(DeviceMock, _super);
    function DeviceMock(browser) {
        var _this = _super.call(this) || this;
        _this.browser = browser;
        _this.browser = browser;
        return _this;
    }
    Object.defineProperty(DeviceMock.prototype, "uuid", {
        get: function () {
            return this.browser.uuid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "platform", {
        get: function () {
            return this.browser.appName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "version", {
        get: function () {
            return this.browser.fullVersion;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "manufacturer", {
        get: function () {
            return this.browser.name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "model", {
        get: function () {
            return '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "cordova", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DeviceMock.prototype, "serial", {
        get: function () {
            return '';
        },
        enumerable: true,
        configurable: true
    });
    return DeviceMock;
}(IonicDevice));
var AppVersionMock = (function () {
    function AppVersionMock() {
    }
    AppVersionMock.prototype.getAppName = function () { return new Promise(function (resolve) { resolve('webapp'); }); };
    AppVersionMock.prototype.getPackageName = function () { return new Promise(function (resolve) { resolve('N/A'); }); };
    AppVersionMock.prototype.getVersionCode = function () { return new Promise(function (resolve) { resolve('N/A'); }); };
    AppVersionMock.prototype.getVersionNumber = function () { return new Promise(function (resolve) { resolve('N/A'); }); };
    return AppVersionMock;
}());
var Device = (function () {
    function Device(plt, utils, batteryStatus, appVersion) {
        var _this = this;
        this.plt = plt;
        this.utils = utils;
        this.batteryStatus = batteryStatus;
        this.appVersion = appVersion;
        console.log("DEVICE INIT - IS CORDOVA " + plt.is('cordova'));
        this.device = plt.is('cordova') ? new IonicDevice() : new DeviceMock(utils.getBrowserFingerprint());
        this.appVersion = plt.is('cordova') ? appVersion : new AppVersionMock();
        this.battery = { level: 'unknown', isCharging: 'unknown' };
        var subscription = this.batteryStatus.onChange().subscribe(function (status) {
            console.log("BATTERY STATUS UPDATE: " + status.level, status.isPlugged);
            _this.battery = { level: status.level, isCharging: status.isPlugged };
        });
    }
    Device.prototype.platform = function () { return this.device.platform.toLowerCase(); };
    Device.prototype.uuid = function () { return this.device.uuid.toLowerCase(); };
    Device.prototype.getDevice = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            Promise.all([
                _this.appVersion.getAppName(),
                _this.appVersion.getPackageName(),
                _this.appVersion.getVersionCode(),
                _this.appVersion.getVersionNumber()
            ]).then(function (config) {
                console.log("BATTERY IS: ", _this.battery);
                var appName = config[0] + "";
                var packageName = config[1] + "";
                var versionCode = config[2] + "";
                var versionNumber = config[3] + "";
                _this.interface =
                    {
                        uuid: _this.device.uuid,
                        platform: _this.getPlatformFromAgent(),
                        version: _this.device.version,
                        manufacturer: _this.device.manufacturer,
                        model: _this.device.model,
                        cordova: _this.device.cordova,
                        serial: _this.device.serial,
                        battery: _this.battery,
                        signal: "0",
                        network: "unknown",
                        appName: appName,
                        packageName: packageName,
                        versionCode: versionCode,
                        versionNumber: versionNumber
                    };
                console.log("DEVICE IS : ", _this.interface);
                resolve(_this.interface);
            });
        });
    };
    Device.prototype.isCordova = function () {
        return this.plt.is('cordova');
    };
    Device.prototype.getPlatformFromAgent = function () {
        if (!document.URL.startsWith('http') || !document.URL.startsWith('https')) {
            return "web";
        }
        if (this.plt.is('windows')) {
            return "windows";
        }
        if (this.plt.is('android')) {
            return "android";
        }
        if (this.plt.is('ios')) {
            return "ios";
        }
        return "unknown";
    };
    Device.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    Device.ctorParameters = function () { return [
        { type: Platform, },
        { type: Utils, },
        { type: BatteryStatus, },
        { type: AppVersion, },
    ]; };
    return Device;
}());
export { Device };
//# sourceMappingURL=index.js.map