import { Observable } from 'rxjs';
import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { CodePush, SyncStatus } from '@ionic-native/code-push';
import { AppVersion } from '@ionic-native/app-version';
import { HTTP } from '@ionic-native/http';
import { BatteryStatus } from '@ionic-native/battery-status';


import { Utils } from './lib/utils';
import { Config } from './lib/config';
import { Consul } from './lib/consul';
import { Database } from './lib/database';
import { Device } from './lib/device';
import { Http } from './lib/http';
import { Socket } from './lib/socket';
import { Toast } from './lib/toast';
import { Update } from './lib/update';
import { Payload } from './lib/payload';
import { Location } from './lib/location';
import { Api } from './lib/api';
import { WebSql } from './lib/database/websql';
import { Sqlite } from './lib/database/sqlite';
import { Status } from './lib/status';



@NgModule({
  declarations: [

  ],
  providers: [
    Utils,
    Config,
    Consul,
    Database,
    Device,
    Http,
    HTTP,
    Socket,
    Toast,
    Update,
    Payload,
    Location,
    Api,
    CodePush,
    WebSql,
    Sqlite,
    AppVersion,
    Status,
    BatteryStatus
  ],
  exports: [
  ],
  imports: [
    BrowserModule
  ],
  schemas: [
    CUSTOM_ELEMENTS_SCHEMA
  ]
})
export class AtajoModule { }
