import { Injectable } from '@angular/core';





@Injectable()
export class Status {

    private static StatusMap: Map<number, string>;

    public static SUCCESS = 0;
    public static NOT_CONNECTED = 1;
    public static TX_TIMEOUT = 2;
    public static LAMBDA_NOT_AVAILABLE = 3;


    constructor() {

        Status.StatusMap = new Map<number, string>([
            [Status.SUCCESS, 'Transaction Successful'],
            [Status.NOT_CONNECTED, 'Device Not Connected'],
            [Status.TX_TIMEOUT, 'Transaction timeout'],
            [Status.LAMBDA_NOT_AVAILABLE, 'Requested Lambda is not available']
        ]);

    }

    static get(id: number) {
        return Status.StatusMap.get(id);
    }


}




