import { Injectable } from '@angular/core';
import { Device } from '../device';
import { Location } from '../location';
import { Utils } from '../utils';
import { Config } from '../config';
var Payload = (function () {
    function Payload(appConfig, deviceProvider, locationProvider, utilsProvider) {
        this.appConfig = appConfig;
        this.deviceProvider = deviceProvider;
        this.locationProvider = locationProvider;
        this.utilsProvider = utilsProvider;
    }
    Payload.prototype.getPayload = function (dataObject, stringify, compress) {
        var _this = this;
        if (stringify === void 0) { stringify = false; }
        if (compress === void 0) { compress = false; }
        var that = this;
        return new Promise(function (resolve, reject) {
            Promise.all([
                _this.deviceProvider.getDevice(),
            ]).then(function (config) {
                var device = config[0];
                // let location: any = config[1];
                // console.log("LOCATION IS : ", location);
                console.log("DEVICE IS : ", device);
                var payload = {
                    "location": {
                        "lat": 0,
                        "lon": 0 //location.coords ? location.coords.longitude : 0
                    },
                    "device": device,
                    "data": dataObject,
                    "pid": _this.utilsProvider.pid()
                };
                resolve(payload);
            });
        });
    };
    Payload.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    Payload.ctorParameters = function () { return [
        { type: Config, },
        { type: Device, },
        { type: Location, },
        { type: Utils, },
    ]; };
    return Payload;
}());
export { Payload };
//# sourceMappingURL=index.js.map